---
title: Rules Lists
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/typescript)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Rules Lists

#### Rules ListsLists

##### [Get lists](https://developers.cloudflare.com/api/typescript/resources/rules/subresources/lists/methods/list)

client.rules.lists.list(ListListParams {account\_id } params, RequestOptionsoptions?): SinglePage< [ListsList](<https://developers.cloudflare.com/api/typescript/resources/rules#(resource)%20rules.lists%20%3E%20(model)%20lists_list%20%3E%20(schema)>) {id, created\_on, kind, 5 more } >

GET/accounts/{account\_id}/rules/lists

##### [Get a list](https://developers.cloudflare.com/api/typescript/resources/rules/subresources/lists/methods/get)

client.rules.lists.get(stringlistID, ListGetParams {account\_id } params, RequestOptionsoptions?): [ListGetResponse](<https://developers.cloudflare.com/api/typescript/resources/rules#(resource)%20rules.lists%20%3E%20(model)%20list_get_response%20%3E%20(schema)>) {id, created\_on, kind, 5 more }

GET/accounts/{account\_id}/rules/lists/{list\_id}

##### [Create a list](https://developers.cloudflare.com/api/typescript/resources/rules/subresources/lists/methods/create)

client.rules.lists.create(ListCreateParams {account\_id, kind, name, description } params, RequestOptionsoptions?): [ListCreateResponse](<https://developers.cloudflare.com/api/typescript/resources/rules#(resource)%20rules.lists%20%3E%20(model)%20list_create_response%20%3E%20(schema)>) {id, created\_on, kind, 5 more }

POST/accounts/{account\_id}/rules/lists

##### [Update a list](https://developers.cloudflare.com/api/typescript/resources/rules/subresources/lists/methods/update)

client.rules.lists.update(stringlistID, ListUpdateParams {account\_id, description } params, RequestOptionsoptions?): [ListUpdateResponse](<https://developers.cloudflare.com/api/typescript/resources/rules#(resource)%20rules.lists%20%3E%20(model)%20list_update_response%20%3E%20(schema)>) {id, created\_on, kind, 5 more }

PUT/accounts/{account\_id}/rules/lists/{list\_id}

##### [Delete a list](https://developers.cloudflare.com/api/typescript/resources/rules/subresources/lists/methods/delete)

client.rules.lists.delete(stringlistID, ListDeleteParams {account\_id } params, RequestOptionsoptions?): [ListDeleteResponse](<https://developers.cloudflare.com/api/typescript/resources/rules#(resource)%20rules.lists%20%3E%20(model)%20list_delete_response%20%3E%20(schema)>) {id }

DELETE/accounts/{account\_id}/rules/lists/{list\_id}

##### ModelsExpand Collapse

<details>

<summary>

Hostname {url\_hostname, exclude\_exact\_hostname }

Hostnames support ASCII(7) letters from a to z, the digits from 0 to 9, wildcards (\*), and the hyphen (-).

</summary>

url\_hostname: string

<a href="#(resource)%20rules.lists%20%3E%20(model)%20hostname%20%3E%20(schema)%20%3E%20(property)%20url_hostname">Link to this property</a>

exclude\_exact\_hostname?: boolean

Only applies to wildcard hostnames (e.g., \*.example.com). When true (default), the rule blocks only subdomains. When false, the rule blocks both the root domain and subdomains.

<a href="#(resource)%20rules.lists%20%3E%20(model)%20hostname%20%3E%20(schema)%20%3E%20(property)%20exclude_exact_hostname">Link to this property</a>

</details>

[Link to this property](<#(resource)%20rules.lists%20%3E%20(model)%20hostname%20%3E%20(schema)>)

<details>

<summary>

ListsList {id, created\_on, kind, 5 more }

</summary>

id: string

The unique ID of the list.

maxLength32

minLength32

<a href="#(resource)%20rules.lists%20%3E%20(model)%20lists_list%20%3E%20(schema)%20%3E%20(property)%20id">Link to this property</a>

created\_on: string

The RFC 3339 timestamp of when the list was created.

<a href="#(resource)%20rules.lists%20%3E%20(model)%20lists_list%20%3E%20(schema)%20%3E%20(property)%20created_on">Link to this property</a>

<details>

<summary>

kind: "ip"| "redirect"| "hostname"| "asn"

The type of the list. Each type supports specific list items (IP addresses, ASNs, hostnames or redirects).

</summary>

One of the following:

"ip"

<a href="#(resource)%20rules.lists%20%3E%20(model)%20lists_list%20%3E%20(schema)%20%3E%20(property)%20kind%20%3E%20(member)%200">Link to this property</a>

"redirect"

<a href="#(resource)%20rules.lists%20%3E%20(model)%20lists_list%20%3E%20(schema)%20%3E%20(property)%20kind%20%3E%20(member)%201">Link to this property</a>

"hostname"

<a href="#(resource)%20rules.lists%20%3E%20(model)%20lists_list%20%3E%20(schema)%20%3E%20(property)%20kind%20%3E%20(member)%202">Link to this property</a>

"asn"

<a href="#(resource)%20rules.lists%20%3E%20(model)%20lists_list%20%3E%20(schema)%20%3E%20(property)%20kind%20%3E%20(member)%203">Link to this property</a>

</details>

<a href="#(resource)%20rules.lists%20%3E%20(model)%20lists_list%20%3E%20(schema)%20%3E%20(property)%20kind">Link to this property</a>

modified\_on: string

The RFC 3339 timestamp of when the list was last modified.

<a href="#(resource)%20rules.lists%20%3E%20(model)%20lists_list%20%3E%20(schema)%20%3E%20(property)%20modified_on">Link to this property</a>

name: string

An informative name for the list. Use this name in filter and rule expressions.

maxLength50

<a href="#(resource)%20rules.lists%20%3E%20(model)%20lists_list%20%3E%20(schema)%20%3E%20(property)%20name">Link to this property</a>

num\_items: number

The number of items in the list.

<a href="#(resource)%20rules.lists%20%3E%20(model)%20lists_list%20%3E%20(schema)%20%3E%20(property)%20num_items">Link to this property</a>

num\_referencing\_filters: number

The number of <a href="https://developers.cloudflare.com/api/resources/filters/">filters</a> referencing the list.

<a href="#(resource)%20rules.lists%20%3E%20(model)%20lists_list%20%3E%20(schema)%20%3E%20(property)%20num_referencing_filters">Link to this property</a>

description?: string

An informative summary of the list.

maxLength500

<a href="#(resource)%20rules.lists%20%3E%20(model)%20lists_list%20%3E%20(schema)%20%3E%20(property)%20description">Link to this property</a>

</details>

[Link to this property](<#(resource)%20rules.lists%20%3E%20(model)%20lists_list%20%3E%20(schema)>)

<details>

<summary>

Redirect {source\_url, target\_url, include\_subdomains, 4 more }

The definition of the redirect.

</summary>

source\_url: string

<a href="#(resource)%20rules.lists%20%3E%20(model)%20redirect%20%3E%20(schema)%20%3E%20(property)%20source_url">Link to this property</a>

target\_url: string

<a href="#(resource)%20rules.lists%20%3E%20(model)%20redirect%20%3E%20(schema)%20%3E%20(property)%20target_url">Link to this property</a>

include\_subdomains?: boolean

<a href="#(resource)%20rules.lists%20%3E%20(model)%20redirect%20%3E%20(schema)%20%3E%20(property)%20include_subdomains">Link to this property</a>

preserve\_path\_suffix?: boolean

<a href="#(resource)%20rules.lists%20%3E%20(model)%20redirect%20%3E%20(schema)%20%3E%20(property)%20preserve_path_suffix">Link to this property</a>

preserve\_query\_string?: boolean

<a href="#(resource)%20rules.lists%20%3E%20(model)%20redirect%20%3E%20(schema)%20%3E%20(property)%20preserve_query_string">Link to this property</a>

<details>

<summary>

status\_code?: 301| 302| 307| 308

</summary>

One of the following:

301

<a href="#(resource)%20rules.lists%20%3E%20(model)%20redirect%20%3E%20(schema)%20%3E%20(property)%20status_code%20%3E%20(member)%200">Link to this property</a>

302

<a href="#(resource)%20rules.lists%20%3E%20(model)%20redirect%20%3E%20(schema)%20%3E%20(property)%20status_code%20%3E%20(member)%201">Link to this property</a>

307

<a href="#(resource)%20rules.lists%20%3E%20(model)%20redirect%20%3E%20(schema)%20%3E%20(property)%20status_code%20%3E%20(member)%202">Link to this property</a>

308

<a href="#(resource)%20rules.lists%20%3E%20(model)%20redirect%20%3E%20(schema)%20%3E%20(property)%20status_code%20%3E%20(member)%203">Link to this property</a>

</details>

<a href="#(resource)%20rules.lists%20%3E%20(model)%20redirect%20%3E%20(schema)%20%3E%20(property)%20status_code">Link to this property</a>

subpath\_matching?: boolean

<a href="#(resource)%20rules.lists%20%3E%20(model)%20redirect%20%3E%20(schema)%20%3E%20(property)%20subpath_matching">Link to this property</a>

</details>

[Link to this property](<#(resource)%20rules.lists%20%3E%20(model)%20redirect%20%3E%20(schema)>)

<details>

<summary>

ListGetResponse {id, created\_on, kind, 5 more }

</summary>

id: string

The unique ID of the list.

maxLength32

minLength32

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_get_response%20%3E%20(schema)%20%3E%20(property)%20id">Link to this property</a>

created\_on: string

The RFC 3339 timestamp of when the list was created.

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_get_response%20%3E%20(schema)%20%3E%20(property)%20created_on">Link to this property</a>

<details>

<summary>

kind: "ip"| "redirect"| "hostname"| "asn"

The type of the list. Each type supports specific list items (IP addresses, ASNs, hostnames or redirects).

</summary>

One of the following:

"ip"

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_get_response%20%3E%20(schema)%20%3E%20(property)%20kind%20%3E%20(member)%200">Link to this property</a>

"redirect"

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_get_response%20%3E%20(schema)%20%3E%20(property)%20kind%20%3E%20(member)%201">Link to this property</a>

"hostname"

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_get_response%20%3E%20(schema)%20%3E%20(property)%20kind%20%3E%20(member)%202">Link to this property</a>

"asn"

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_get_response%20%3E%20(schema)%20%3E%20(property)%20kind%20%3E%20(member)%203">Link to this property</a>

</details>

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_get_response%20%3E%20(schema)%20%3E%20(property)%20kind">Link to this property</a>

modified\_on: string

The RFC 3339 timestamp of when the list was last modified.

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_get_response%20%3E%20(schema)%20%3E%20(property)%20modified_on">Link to this property</a>

name: string

An informative name for the list. Use this name in filter and rule expressions.

maxLength50

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_get_response%20%3E%20(schema)%20%3E%20(property)%20name">Link to this property</a>

num\_items: number

The number of items in the list.

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_get_response%20%3E%20(schema)%20%3E%20(property)%20num_items">Link to this property</a>

num\_referencing\_filters: number

The number of <a href="https://developers.cloudflare.com/api/resources/filters/">filters</a> referencing the list.

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_get_response%20%3E%20(schema)%20%3E%20(property)%20num_referencing_filters">Link to this property</a>

description?: string

An informative summary of the list.

maxLength500

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_get_response%20%3E%20(schema)%20%3E%20(property)%20description">Link to this property</a>

</details>

[Link to this property](<#(resource)%20rules.lists%20%3E%20(model)%20list_get_response%20%3E%20(schema)>)

<details>

<summary>

ListCreateResponse {id, created\_on, kind, 5 more }

</summary>

id: string

The unique ID of the list.

maxLength32

minLength32

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_create_response%20%3E%20(schema)%20%3E%20(property)%20id">Link to this property</a>

created\_on: string

The RFC 3339 timestamp of when the list was created.

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_create_response%20%3E%20(schema)%20%3E%20(property)%20created_on">Link to this property</a>

<details>

<summary>

kind: "ip"| "redirect"| "hostname"| "asn"

The type of the list. Each type supports specific list items (IP addresses, ASNs, hostnames or redirects).

</summary>

One of the following:

"ip"

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_create_response%20%3E%20(schema)%20%3E%20(property)%20kind%20%3E%20(member)%200">Link to this property</a>

"redirect"

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_create_response%20%3E%20(schema)%20%3E%20(property)%20kind%20%3E%20(member)%201">Link to this property</a>

"hostname"

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_create_response%20%3E%20(schema)%20%3E%20(property)%20kind%20%3E%20(member)%202">Link to this property</a>

"asn"

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_create_response%20%3E%20(schema)%20%3E%20(property)%20kind%20%3E%20(member)%203">Link to this property</a>

</details>

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_create_response%20%3E%20(schema)%20%3E%20(property)%20kind">Link to this property</a>

modified\_on: string

The RFC 3339 timestamp of when the list was last modified.

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_create_response%20%3E%20(schema)%20%3E%20(property)%20modified_on">Link to this property</a>

name: string

An informative name for the list. Use this name in filter and rule expressions.

maxLength50

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_create_response%20%3E%20(schema)%20%3E%20(property)%20name">Link to this property</a>

num\_items: number

The number of items in the list.

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_create_response%20%3E%20(schema)%20%3E%20(property)%20num_items">Link to this property</a>

num\_referencing\_filters: number

The number of <a href="https://developers.cloudflare.com/api/resources/filters/">filters</a> referencing the list.

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_create_response%20%3E%20(schema)%20%3E%20(property)%20num_referencing_filters">Link to this property</a>

description?: string

An informative summary of the list.

maxLength500

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_create_response%20%3E%20(schema)%20%3E%20(property)%20description">Link to this property</a>

</details>

[Link to this property](<#(resource)%20rules.lists%20%3E%20(model)%20list_create_response%20%3E%20(schema)>)

<details>

<summary>

ListUpdateResponse {id, created\_on, kind, 5 more }

</summary>

id: string

The unique ID of the list.

maxLength32

minLength32

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_update_response%20%3E%20(schema)%20%3E%20(property)%20id">Link to this property</a>

created\_on: string

The RFC 3339 timestamp of when the list was created.

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_update_response%20%3E%20(schema)%20%3E%20(property)%20created_on">Link to this property</a>

<details>

<summary>

kind: "ip"| "redirect"| "hostname"| "asn"

The type of the list. Each type supports specific list items (IP addresses, ASNs, hostnames or redirects).

</summary>

One of the following:

"ip"

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_update_response%20%3E%20(schema)%20%3E%20(property)%20kind%20%3E%20(member)%200">Link to this property</a>

"redirect"

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_update_response%20%3E%20(schema)%20%3E%20(property)%20kind%20%3E%20(member)%201">Link to this property</a>

"hostname"

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_update_response%20%3E%20(schema)%20%3E%20(property)%20kind%20%3E%20(member)%202">Link to this property</a>

"asn"

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_update_response%20%3E%20(schema)%20%3E%20(property)%20kind%20%3E%20(member)%203">Link to this property</a>

</details>

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_update_response%20%3E%20(schema)%20%3E%20(property)%20kind">Link to this property</a>

modified\_on: string

The RFC 3339 timestamp of when the list was last modified.

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_update_response%20%3E%20(schema)%20%3E%20(property)%20modified_on">Link to this property</a>

name: string

An informative name for the list. Use this name in filter and rule expressions.

maxLength50

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_update_response%20%3E%20(schema)%20%3E%20(property)%20name">Link to this property</a>

num\_items: number

The number of items in the list.

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_update_response%20%3E%20(schema)%20%3E%20(property)%20num_items">Link to this property</a>

num\_referencing\_filters: number

The number of <a href="https://developers.cloudflare.com/api/resources/filters/">filters</a> referencing the list.

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_update_response%20%3E%20(schema)%20%3E%20(property)%20num_referencing_filters">Link to this property</a>

description?: string

An informative summary of the list.

maxLength500

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_update_response%20%3E%20(schema)%20%3E%20(property)%20description">Link to this property</a>

</details>

[Link to this property](<#(resource)%20rules.lists%20%3E%20(model)%20list_update_response%20%3E%20(schema)>)

<details>

<summary>

ListDeleteResponse {id }

</summary>

id: string

The unique ID of the list.

maxLength32

minLength32

<a href="#(resource)%20rules.lists%20%3E%20(model)%20list_delete_response%20%3E%20(schema)%20%3E%20(property)%20id">Link to this property</a>

</details>

[Link to this property](<#(resource)%20rules.lists%20%3E%20(model)%20list_delete_response%20%3E%20(schema)>)

#### Rules ListsListsBulk Operations

##### [Get bulk operation status](https://developers.cloudflare.com/api/typescript/resources/rules/subresources/lists/subresources/bulk_operations/methods/get)

client.rules.lists.bulkOperations.get(stringoperationID, BulkOperationGetParams {account\_id } params, RequestOptionsoptions?): [BulkOperationGetResponse](<https://developers.cloudflare.com/api/typescript/resources/rules#(resource)%20rules.lists.bulk_operations%20%3E%20(model)%20bulk_operation_get_response%20%3E%20(schema)>)

GET/accounts/{account\_id}/rules/lists/bulk\_operations/{operation\_id}

##### ModelsExpand Collapse

<details>

<summary>

BulkOperationGetResponse = ListsBulkOperationPendingOrRunning {id, status } | ListsBulkOperationCompleted {id, completed, status } | ListsBulkOperationFailed {id, completed, error, status }

</summary>

One of the following:

<details>

<summary>

ListsBulkOperationPendingOrRunning {id, status }

</summary>

id: string

The unique operation ID of the asynchronous action.

<a href="#(resource)%20rules.lists.bulk_operations%20%3E%20(model)%20bulk_operation_get_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20id">Link to this property</a>

<details>

<summary>

status: "pending"| "running"

The current status of the asynchronous operation.

</summary>

One of the following:

"pending"

<a href="#(resource)%20rules.lists.bulk_operations%20%3E%20(model)%20bulk_operation_get_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20status%20%3E%20(member)%200">Link to this property</a>

"running"

<a href="#(resource)%20rules.lists.bulk_operations%20%3E%20(model)%20bulk_operation_get_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20status%20%3E%20(member)%201">Link to this property</a>

</details>

<a href="#(resource)%20rules.lists.bulk_operations%20%3E%20(model)%20bulk_operation_get_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20status">Link to this property</a>

</details>

<a href="#(resource)%20rules.lists.bulk_operations%20%3E%20(model)%20bulk_operation_get_response%20%3E%20(schema)%20%3E%20(variant)%200">Link to this property</a>

<details>

<summary>

ListsBulkOperationCompleted {id, completed, status }

</summary>

id: string

The unique operation ID of the asynchronous action.

<a href="#(resource)%20rules.lists.bulk_operations%20%3E%20(model)%20bulk_operation_get_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20id">Link to this property</a>

completed: string

The RFC 3339 timestamp of when the operation was completed.

<a href="#(resource)%20rules.lists.bulk_operations%20%3E%20(model)%20bulk_operation_get_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20completed">Link to this property</a>

status: "completed"

The current status of the asynchronous operation.

<a href="#(resource)%20rules.lists.bulk_operations%20%3E%20(model)%20bulk_operation_get_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20status">Link to this property</a>

</details>

<a href="#(resource)%20rules.lists.bulk_operations%20%3E%20(model)%20bulk_operation_get_response%20%3E%20(schema)%20%3E%20(variant)%201">Link to this property</a>

<details>

<summary>

ListsBulkOperationFailed {id, completed, error, status }

</summary>

id: string

The unique operation ID of the asynchronous action.

<a href="#(resource)%20rules.lists.bulk_operations%20%3E%20(model)%20bulk_operation_get_response%20%3E%20(schema)%20%3E%20(variant)%202%20%3E%20(property)%20id">Link to this property</a>

completed: string

The RFC 3339 timestamp of when the operation was completed.

<a href="#(resource)%20rules.lists.bulk_operations%20%3E%20(model)%20bulk_operation_get_response%20%3E%20(schema)%20%3E%20(variant)%202%20%3E%20(property)%20completed">Link to this property</a>

error: string

A message describing the error when the status is <code>failed</code>.

<a href="#(resource)%20rules.lists.bulk_operations%20%3E%20(model)%20bulk_operation_get_response%20%3E%20(schema)%20%3E%20(variant)%202%20%3E%20(property)%20error">Link to this property</a>

status: "failed"

The current status of the asynchronous operation.

<a href="#(resource)%20rules.lists.bulk_operations%20%3E%20(model)%20bulk_operation_get_response%20%3E%20(schema)%20%3E%20(variant)%202%20%3E%20(property)%20status">Link to this property</a>

</details>

<a href="#(resource)%20rules.lists.bulk_operations%20%3E%20(model)%20bulk_operation_get_response%20%3E%20(schema)%20%3E%20(variant)%202">Link to this property</a>

</details>

[Link to this property](<#(resource)%20rules.lists.bulk_operations%20%3E%20(model)%20bulk_operation_get_response%20%3E%20(schema)>)

#### Rules ListsListsItems

##### [Get list items](https://developers.cloudflare.com/api/typescript/resources/rules/subresources/lists/subresources/items/methods/list)

client.rules.lists.items.list(stringlistID, ItemListParams {account\_id, cursor, per\_page, search } params, RequestOptionsoptions?): CursorPaginationAfter< [ItemListResponse](<https://developers.cloudflare.com/api/typescript/resources/rules#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)>)>

GET/accounts/{account\_id}/rules/lists/{list\_id}/items

##### [Get a list item](https://developers.cloudflare.com/api/typescript/resources/rules/subresources/lists/subresources/items/methods/get)

client.rules.lists.items.get(stringitemID, ItemGetParams {account\_id, list\_id } params, RequestOptionsoptions?): [ItemGetResponse](<https://developers.cloudflare.com/api/typescript/resources/rules#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)>)

GET/accounts/{account\_id}/rules/lists/{list\_id}/items/{item\_id}

##### [Create list items](https://developers.cloudflare.com/api/typescript/resources/rules/subresources/lists/subresources/items/methods/create)

client.rules.lists.items.create(stringlistID, ItemCreateParams {account\_id, body } params, RequestOptionsoptions?): [ItemCreateResponse](<https://developers.cloudflare.com/api/typescript/resources/rules#(resource)%20rules.lists.items%20%3E%20(model)%20item_create_response%20%3E%20(schema)>) {operation\_id }

POST/accounts/{account\_id}/rules/lists/{list\_id}/items

##### [Update all list items](https://developers.cloudflare.com/api/typescript/resources/rules/subresources/lists/subresources/items/methods/update)

client.rules.lists.items.update(stringlistID, ItemUpdateParams {account\_id, body } params, RequestOptionsoptions?): [ItemUpdateResponse](<https://developers.cloudflare.com/api/typescript/resources/rules#(resource)%20rules.lists.items%20%3E%20(model)%20item_update_response%20%3E%20(schema)>) {operation\_id }

PUT/accounts/{account\_id}/rules/lists/{list\_id}/items

##### [Delete list items](https://developers.cloudflare.com/api/typescript/resources/rules/subresources/lists/subresources/items/methods/delete)

client.rules.lists.items.delete(stringlistID, ItemDeleteParams {account\_id, items } params, RequestOptionsoptions?): [ItemDeleteResponse](<https://developers.cloudflare.com/api/typescript/resources/rules#(resource)%20rules.lists.items%20%3E%20(model)%20item_delete_response%20%3E%20(schema)>) {operation\_id }

DELETE/accounts/{account\_id}/rules/lists/{list\_id}/items

##### ModelsExpand Collapse

<details>

<summary>

ListCursor {after, before }

</summary>

after?: string

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20list_cursor%20%3E%20(schema)%20%3E%20(property)%20after">Link to this property</a>

before?: string

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20list_cursor%20%3E%20(schema)%20%3E%20(property)%20before">Link to this property</a>

</details>

[Link to this property](<#(resource)%20rules.lists.items%20%3E%20(model)%20list_cursor%20%3E%20(schema)>)

<details>

<summary>

ListItem {operation\_id }

</summary>

operation\_id: string

The unique operation ID of the asynchronous action.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20list_item%20%3E%20(schema)%20%3E%20(property)%20operation_id">Link to this property</a>

</details>

[Link to this property](<#(resource)%20rules.lists.items%20%3E%20(model)%20list_item%20%3E%20(schema)>)

<details>

<summary>

ItemListResponse = ListsListItemIPFull {id, created\_on, ip, 2 more } | ListsListItemHostnameFull {id, created\_on, hostname, 2 more } | ListsListItemRedirectFull {id, created\_on, modified\_on, 2 more } | ListsListItemASNFull {id, asn, created\_on, 2 more }

</summary>

One of the following:

<details>

<summary>

ListsListItemIPFull {id, created\_on, ip, 2 more }

</summary>

id: string

Defines the unique ID of the item in the List.

maxLength32

minLength32

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20id">Link to this property</a>

created\_on: string

The RFC 3339 timestamp of when the list was created.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20created_on">Link to this property</a>

ip: string

An IPv4 address, an IPv4 CIDR, an IPv6 address, or an IPv6 CIDR.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20ip">Link to this property</a>

modified\_on: string

The RFC 3339 timestamp of when the list was last modified.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20modified_on">Link to this property</a>

comment?: string

Defines an informative summary of the list item.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20comment">Link to this property</a>

</details>

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)%20%3E%20(variant)%200">Link to this property</a>

<details>

<summary>

ListsListItemHostnameFull {id, created\_on, hostname, 2 more }

</summary>

id: string

Defines the unique ID of the item in the List.

maxLength32

minLength32

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20id">Link to this property</a>

created\_on: string

The RFC 3339 timestamp of when the list was created.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20created_on">Link to this property</a>

hostname: <a href="https://developers.cloudflare.com/api/typescript/resources/rules#(resource)%20rules.lists%20%3E%20(model)%20hostname%20%3E%20(schema)">Hostname</a> {url\_hostname, exclude\_exact\_hostname }

Hostnames support ASCII(7) letters from a to z, the digits from 0 to 9, wildcards (\*), and the hyphen (-).

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20hostname">Link to this property</a>

modified\_on: string

The RFC 3339 timestamp of when the list was last modified.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20modified_on">Link to this property</a>

comment?: string

Defines an informative summary of the list item.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20comment">Link to this property</a>

</details>

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)%20%3E%20(variant)%201">Link to this property</a>

<details>

<summary>

ListsListItemRedirectFull {id, created\_on, modified\_on, 2 more }

</summary>

id: string

Defines the unique ID of the item in the List.

maxLength32

minLength32

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)%20%3E%20(variant)%202%20%3E%20(property)%20id">Link to this property</a>

created\_on: string

The RFC 3339 timestamp of when the list was created.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)%20%3E%20(variant)%202%20%3E%20(property)%20created_on">Link to this property</a>

modified\_on: string

The RFC 3339 timestamp of when the list was last modified.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)%20%3E%20(variant)%202%20%3E%20(property)%20modified_on">Link to this property</a>

redirect: <a href="https://developers.cloudflare.com/api/typescript/resources/rules#(resource)%20rules.lists%20%3E%20(model)%20redirect%20%3E%20(schema)">Redirect</a> {source\_url, target\_url, include\_subdomains, 4 more }

The definition of the redirect.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)%20%3E%20(variant)%202%20%3E%20(property)%20redirect">Link to this property</a>

comment?: string

Defines an informative summary of the list item.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)%20%3E%20(variant)%202%20%3E%20(property)%20comment">Link to this property</a>

</details>

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)%20%3E%20(variant)%202">Link to this property</a>

<details>

<summary>

ListsListItemASNFull {id, asn, created\_on, 2 more }

</summary>

id: string

Defines the unique ID of the item in the List.

maxLength32

minLength32

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)%20%3E%20(variant)%203%20%3E%20(property)%20id">Link to this property</a>

asn: number

Defines a non-negative 32 bit integer.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)%20%3E%20(variant)%203%20%3E%20(property)%20asn">Link to this property</a>

created\_on: string

The RFC 3339 timestamp of when the list was created.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)%20%3E%20(variant)%203%20%3E%20(property)%20created_on">Link to this property</a>

modified\_on: string

The RFC 3339 timestamp of when the list was last modified.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)%20%3E%20(variant)%203%20%3E%20(property)%20modified_on">Link to this property</a>

comment?: string

Defines an informative summary of the list item.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)%20%3E%20(variant)%203%20%3E%20(property)%20comment">Link to this property</a>

</details>

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)%20%3E%20(variant)%203">Link to this property</a>

</details>

[Link to this property](<#(resource)%20rules.lists.items%20%3E%20(model)%20item_list_response%20%3E%20(schema)>)

<details>

<summary>

ItemGetResponse = ListsListItemIPFull {id, created\_on, ip, 2 more } | ListsListItemHostnameFull {id, created\_on, hostname, 2 more } | ListsListItemRedirectFull {id, created\_on, modified\_on, 2 more } | ListsListItemASNFull {id, asn, created\_on, 2 more }

</summary>

One of the following:

<details>

<summary>

ListsListItemIPFull {id, created\_on, ip, 2 more }

</summary>

id: string

Defines the unique ID of the item in the List.

maxLength32

minLength32

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20id">Link to this property</a>

created\_on: string

The RFC 3339 timestamp of when the list was created.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20created_on">Link to this property</a>

ip: string

An IPv4 address, an IPv4 CIDR, an IPv6 address, or an IPv6 CIDR.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20ip">Link to this property</a>

modified\_on: string

The RFC 3339 timestamp of when the list was last modified.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20modified_on">Link to this property</a>

comment?: string

Defines an informative summary of the list item.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20comment">Link to this property</a>

</details>

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)%20%3E%20(variant)%200">Link to this property</a>

<details>

<summary>

ListsListItemHostnameFull {id, created\_on, hostname, 2 more }

</summary>

id: string

Defines the unique ID of the item in the List.

maxLength32

minLength32

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20id">Link to this property</a>

created\_on: string

The RFC 3339 timestamp of when the list was created.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20created_on">Link to this property</a>

hostname: <a href="https://developers.cloudflare.com/api/typescript/resources/rules#(resource)%20rules.lists%20%3E%20(model)%20hostname%20%3E%20(schema)">Hostname</a> {url\_hostname, exclude\_exact\_hostname }

Hostnames support ASCII(7) letters from a to z, the digits from 0 to 9, wildcards (\*), and the hyphen (-).

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20hostname">Link to this property</a>

modified\_on: string

The RFC 3339 timestamp of when the list was last modified.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20modified_on">Link to this property</a>

comment?: string

Defines an informative summary of the list item.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20comment">Link to this property</a>

</details>

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)%20%3E%20(variant)%201">Link to this property</a>

<details>

<summary>

ListsListItemRedirectFull {id, created\_on, modified\_on, 2 more }

</summary>

id: string

Defines the unique ID of the item in the List.

maxLength32

minLength32

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)%20%3E%20(variant)%202%20%3E%20(property)%20id">Link to this property</a>

created\_on: string

The RFC 3339 timestamp of when the list was created.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)%20%3E%20(variant)%202%20%3E%20(property)%20created_on">Link to this property</a>

modified\_on: string

The RFC 3339 timestamp of when the list was last modified.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)%20%3E%20(variant)%202%20%3E%20(property)%20modified_on">Link to this property</a>

redirect: <a href="https://developers.cloudflare.com/api/typescript/resources/rules#(resource)%20rules.lists%20%3E%20(model)%20redirect%20%3E%20(schema)">Redirect</a> {source\_url, target\_url, include\_subdomains, 4 more }

The definition of the redirect.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)%20%3E%20(variant)%202%20%3E%20(property)%20redirect">Link to this property</a>

comment?: string

Defines an informative summary of the list item.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)%20%3E%20(variant)%202%20%3E%20(property)%20comment">Link to this property</a>

</details>

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)%20%3E%20(variant)%202">Link to this property</a>

<details>

<summary>

ListsListItemASNFull {id, asn, created\_on, 2 more }

</summary>

id: string

Defines the unique ID of the item in the List.

maxLength32

minLength32

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)%20%3E%20(variant)%203%20%3E%20(property)%20id">Link to this property</a>

asn: number

Defines a non-negative 32 bit integer.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)%20%3E%20(variant)%203%20%3E%20(property)%20asn">Link to this property</a>

created\_on: string

The RFC 3339 timestamp of when the list was created.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)%20%3E%20(variant)%203%20%3E%20(property)%20created_on">Link to this property</a>

modified\_on: string

The RFC 3339 timestamp of when the list was last modified.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)%20%3E%20(variant)%203%20%3E%20(property)%20modified_on">Link to this property</a>

comment?: string

Defines an informative summary of the list item.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)%20%3E%20(variant)%203%20%3E%20(property)%20comment">Link to this property</a>

</details>

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)%20%3E%20(variant)%203">Link to this property</a>

</details>

[Link to this property](<#(resource)%20rules.lists.items%20%3E%20(model)%20item_get_response%20%3E%20(schema)>)

<details>

<summary>

ItemCreateResponse {operation\_id }

</summary>

operation\_id: string

The unique operation ID of the asynchronous action.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_create_response%20%3E%20(schema)%20%3E%20(property)%20operation_id">Link to this property</a>

</details>

[Link to this property](<#(resource)%20rules.lists.items%20%3E%20(model)%20item_create_response%20%3E%20(schema)>)

<details>

<summary>

ItemUpdateResponse {operation\_id }

</summary>

operation\_id: string

The unique operation ID of the asynchronous action.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_update_response%20%3E%20(schema)%20%3E%20(property)%20operation_id">Link to this property</a>

</details>

[Link to this property](<#(resource)%20rules.lists.items%20%3E%20(model)%20item_update_response%20%3E%20(schema)>)

<details>

<summary>

ItemDeleteResponse {operation\_id }

</summary>

operation\_id: string

The unique operation ID of the asynchronous action.

<a href="#(resource)%20rules.lists.items%20%3E%20(model)%20item_delete_response%20%3E%20(schema)%20%3E%20(property)%20operation_id">Link to this property</a>

</details>

[Link to this property](<#(resource)%20rules.lists.items%20%3E%20(model)%20item_delete_response%20%3E%20(schema)>)